/*
Mtrack v2
2006 Will Wei

ViewClient class
*/

ViewClient = Class.create()
ViewClient.prototype = {
	
	// Empty Constructor
	initialize : function ()
	{
		this.loadScreen 			= "ls";
		this.imageScreen			= "is";
		this.imageSrc				= "";
		this.elementScreen			= "es";
		this.elementSrc				= "";
		
		// Creates the "static" common class
		Connection 	= new ConnectionClass();
		UI			= new ViewUI(this);
		Site		= new SiteClass();
	},
	
	Start : function ()
	{
		
		this.GetImageSrc.apply(this);
		
		this.LoadUI();
		this.ShowUI();
		
		Site.SetMod("view");
		Site.FixLinks();
		Site.FixForms();
		
		window.onunload = this.CloseSession.bind(this);
	},
	
	GetImageSrc : function () {
	    this.ShowLoadScreen();
	    
		Connection.command("LoadImage","&url=" + Connection.get("url") + 
							"&image_options=" + this.GetImageOptions() +
							"&elements=" + Site.GetElementsInfo() +  
							"&image_data_options=" +this.GetImageDataOptions()
							,this.LoadImage.bind(this));
	},
	
	LoadImage : function (response)	{
		
		Logger.log(response.responseText);
		imageList = response.responseText.split(":");
		
		this.imageSrc = imageList[0];
		this.elementSrc = imageList[1];
		this.HideLoadScreen();
		this.ShowImage();
		this.ShowElementImage();
	},
	
	// Sends the command to delete the image files 
	CloseSession : function () {
		
		Connection.command("ClearImage","&mousefile=" + this.imageSrc + "&elementfile=" + this.elementSrc,false);
	},
	
	//-------------------------------------------
	// Image Options Related Functions
	//-------------------------------------------
	
	GetImageOptions : function () {
		
		options = new Array();
		options.push(new Array("image_width",Site.GetPageWidth()));
		options.push(new Array("image_height",Site.GetPageHeight()));
		
		for(i=0;i<options.length;i++)
			options[i] = options[i].join("|");
			
		return options;
	},
	
	//-------------------------------------------
	// Loading Screen Related Functions
	//-------------------------------------------
	ShowLoadScreen : function ()
	{
		
		// Creates the div
		loadScreen = document.createElement("div");
		loadScreen.setAttribute("id",this.loadScreen);
		
		// Configures the loading screen
		x = "50px";
		y = "50px";
		width = "200px";
		height = "100px";
		backcolor = "#333333";
		style = "left:"+x+";top:"+y+";width:"+width+";height:"+height+";background-color:"+backcolor+";position:absolute;float:left;color:#FFFFFF;font-family:Arial;font-weight:bold;text-align:center";
		loadScreen.setAttribute("style",style);
		loadScreen.innerHTML = "<br /><br />Loading...";
		
		// Displays the load screen
		document.body.appendChild(loadScreen);
	},
	
	HideLoadScreen : function ()
	{
		loadScreen = document.getElementById(this.loadScreen);
		if(loadScreen !=null)
			document.body.removeChild(loadScreen);
	},
	
	
	//-------------------------------------------------------
	// MouseImage related functions
	//-------------------------------------------------------
	
	ShowImage : function ()
	{
		
		// Creates the div
		imageScreen = document.createElement("div");
		
		imageScreen.setAttribute("id",this.imageScreen);
		
		// Configures the image screen
		style = "left:0px;top:0px;position:absolute;float:left;";
		imageScreen.setAttribute("style",style);
		
		// Configures the image
		image = document.createElement("img");
		image.setAttribute("src",this.imageSrc);
		
		
		// Adds the image to the document
		imageScreen.appendChild(image);
		document.body.appendChild(imageScreen);
	},

	ShowElementImage : function ()
	{
		// Creates the div
		elementScreen = document.createElement("div");
		elementScreen.setAttribute("id",this.elementScreen);
		
		// Configures the image screen
		style = "left:0px;top:0px;position:absolute;float:left;";
		elementScreen.setAttribute("style",style);
		
		// Configures the image
		image = document.createElement("img");
		image.setAttribute("src",this.elementSrc);
		
		// Adds the image to the document
		elementScreen.appendChild(image);
		document.body.appendChild(elementScreen);
	},
	

	HideImage : function ()
	{
		if( (imageScreen = document.getElementById(this.imageScreen)) != null)
			document.body.removeChild(imageScreen);
	},
	
	
	//
	
	//----------------------------------------------
	// UI Related Functions
	//----------------------------------------------
	
	LoadUI : function ()
	{
	},
	
	ShowUI : function ()
	{
	},
	
	HideUI : function ()
	{
	},
	
	MiniUI : function ()
	{
	},
	
	
	//------------------------------------------------
	// Image Data Options
	//------------------------------------------------
	
	GetImageDataOptions : function() {
		return "data_session_limit|5";
	}
};

viewClient = new ViewClient();
window.onload = function () { viewClient.Start() };
