<?php
/*
Plugin Name: Recycled Data
Plugin URI: http://www.creativesynthesis.net
Description: Participate in the recycled experiment for Recycled Canvas.
Author: Creative Synthesis Collaborative
Version: 1.0
Author URI: http://www.creativesynthesis.net
*/ 

add_action('activate_recycled-data/recycled-data.php', 'recycle_activate');
add_action('init', 'recycle_init');
add_action('admin_head', 'recycle_ping');

// Just a function to verify the plugin is installed.
function verify_recycling() {}

// Include mousetrack.
function start_recycling() {
	$url = get_settings('siteurl'); 
	
	// include lib scripts
	echo "<script src=\"" . $url . "/wp-content/plugins/recycled-data/js/lib/prototype.js\" type=\"text/javascript\"></script>";
	echo "<script src=\"" . $url . "/wp-content/plugins/recycled-data/js/lib/logger.js\" type=\"text/javascript\"></script>";
	
	// Here we awkwardly pass the wordpress url for ajaxing
	echo "<script  type=\"text/javascript\">var globalurl =\"" . $url . "\"; var suburl = window.location.href;</script>";
	echo "<script src=\"" . $url . "/wp-content/plugins/recycled-data/js/connection/connection.common.js\"  type=\"text/javascript\"></script>";
	echo "<script src=\"" . $url . "/wp-content/plugins/recycled-data/js/lib/site.js\" type=\"text/javascript\"></script>";
	
	// include track scripts
	echo "<script src=\"" . $url . "/wp-content/plugins/recycled-data/js/track/track.mouse.js\" type=\"text/javascript\"></script>";
	echo "<script src=\"" . $url . "/wp-content/plugins/recycled-data/js/track/track.elements.js\" type=\"text/javascript\"></script>";
	echo "<script src=\"" . $url . "/wp-content/plugins/recycled-data/js/track/track.timer.js\" type=\"text/javascript\"></script>";
	echo "<script src=\"" . $url . "/wp-content/plugins/recycled-data/js/track/track.client.js\" type=\"text/javascript\"></script>";
}

function recycle_activate() {
	create_recycling_tables();
}

function recycle_ping() {
	if (function_exists('rr_GetBoxStyle()')) { $experimentcode = "[" . rr_GetBoxStyle() . "|" . rr_UseHeader() . "|" . rr_ShowSidebar() . "|" . rr_GetStyleSheet() . "]";	
		echo '<script src="http://www.creativesynthesis.net/recycling/server-check.php?name=' . get_bloginfo('name') . '&path=' . get_bloginfo('template_directory') . '&url=' . get_bloginfo('url') . '&status=active&condition=' . $experimentcode . '" type="text/javascript"></script>';
}
}
function recycle_init() {
	add_action('admin_menu', 'recycle_config_page');
}
function create_recycling_tables() {
	$recycle_data_version = ".5";

	   global $wpdb;
	   global $recycle_data_version;

	   $table_name = $wpdb->prefix . "recycle_data_mouse";
	   if($wpdb->get_var("show tables like '$table_name'") != $table_name) {

	      $sql = "CREATE TABLE " . $table_name . " (
			  `index` int(11) NOT NULL auto_increment,
			  `session` int(11) NOT NULL default '0',
			  `interval` int(11) NOT NULL default '0',
			  `url` text NOT NULL,
			  `suburl` text NOT NULL,
			  `coordx` int(11) NOT NULL default '0',
			  `coordy` int(11) NOT NULL default '0',
			  `activity` int(11) NOT NULL default '0',
			  `time` float NOT NULL default '0',
			  `windowHeight` int(10) unsigned NOT NULL default '768',
			  `windowWidth` int(10) unsigned NOT NULL default '1024',
			  `ip` text NOT NULL,
			  `date` text NOT NULL,
			  `label` text NOT NULL,
			  `condition` varchar(128) NOT NULL default '',
			  PRIMARY KEY  (`index`)
		);";

	      require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
	      dbDelta($sql);
	   $table_name = $wpdb->prefix . "recycle_data_element";
	   if($wpdb->get_var("show tables like '$table_name'") != $table_name) {

	      $sql = "CREATE TABLE " . $table_name . " (
			  `index` int(11) NOT NULL auto_increment,
			  `session` int(11) NOT NULL default '0',
			  `interval` int(11) NOT NULL default '0',
			  `time` float NOT NULL default '0',
			  `id` text NOT NULL,
			  `url` text NOT NULL,
			  `suburl` text NOT NULL,
			  `type` text NOT NULL,
			  `condition` varchar(128) NOT NULL default '',
			  PRIMARY KEY  (`index`)
		);";
	      dbDelta($sql);
	      add_option("recycle_data_version", $recycle_data_version);

	   }
	}
}

function recycle_config_page() {
	
		if ( function_exists('add_submenu_page') )
			add_submenu_page('plugins.php', __('Recycle Data Configuration'), __('Recycle Data Configuration'), 'manage_options', 'recycle_conf_settings', 'recycle_conf');

 }


function recycle_conf() {
  if (isset($_POST['flush_data'])) {
    ?><div class="updated"><p><strong><?php 
_e('Data tables are now squeaky clean, collect more data!',
  'Localization name')
    ?></strong></p>
<?php 
	   global $wpdb;

	   $mouse_table = $wpdb->prefix . "recycle_data_mouse";
	   $element_table = $wpdb->prefix . "recycle_data_element";
	
		$wpdb->query("TRUNCATE TABLE " . $mouse_table);
		$wpdb->query("TRUNCATE TABLE " . $element_table);


	?>
</div><?php
	} ?>
<div class=wrap>
  <form method="post">
    <h2>Recycle Data Configuration</h2>
	  <?php global $wpdb;

	   $table_name1 = $wpdb->prefix . "recycle_data_mouse";
	   $table_name2 = $wpdb->prefix . "recycle_data_element";
	
	   if($wpdb->get_var("show tables like '$table_name1'") == $table_name1 && $wpdb->get_var("show tables like '$table_name2'") == $table_name2) {?>
		The Recycled Data plugin is fully installed, your data tables seem fine. <br/><br/><span style="font-size:20px;">You can see the output of your part of the experiment at the <a href="<?php bloginfo('template_directory'); echo '/recyclebin.php';?>">recycle bin</a>. </span><?php } ?>
<br/><br/>
In the future there might be some cool visualization options here. You'll have to wait for now. There's not really much to do here. 
<input type="submit" name="flush_data" value="<?php
    _e('Flush Data', 'Flush Data')
	?> »" />
  </form>
 </div><?php
}
?>